> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pinkfish.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# commercetools-orders

> commercetools Orders - manage orders, carts, payments, and payment methods

**Server path:** `/commercetools-orders` | **Type:** Application | **PCID required:** Yes

## Tools

| Tool                                                                                                                                  | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| ------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [`commercetools_orders_create_carts`](#commercetools_orders_create_carts)                                                             | Creates a Cart in the Project.  If the referenced ShippingMethod in the CartDraft has a predicate that does not match, or if the Shipping Method is not active, an InvalidOperation error is returned.  Specific Error Codes:  - DiscountCodeNonApplicable - InvalidItemShippingDetails - MatchingPriceNotFound - MissingTaxRateForCountry                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| [`commercetools_orders_create_carts_customer_id_customer_id_merge`](#commercetools_orders_create_carts_customer_id_customer_id_merge) | Merges items from an anonymous Cart into the most recently modified active Cart of a Customer. If no active Cart exists, the anonymous Cart becomes the Customer's active Cart. For more information about merge mode behaviors, merge rules, and tax recalculation, see Merge a Cart.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| [`commercetools_orders_create_carts_replicate`](#commercetools_orders_create_carts_replicate)                                         | Creates a new Cart by replicating an existing Cart or Order.  The following applies to the new Cart:  - It contains the same Customer information, Line Items and Custom Line Items, Custom Fields, Discount Codes, and other settings of the originating Cart or Order. - If a Line Item becomes invalid, it is removed from the new Cart. A common reason for this is removed Products or Prices. - Line items and Custom Line Items are reset to their initial state. - It contains no payments or delivery information. - It contains up-to-date Tax Rates, Prices, and Line Item product data. - The CartState is `Active`. - If using the `customerGroup` field (for a single Customer Group) and the referenced Customer switched to another Customer Group, the new Cart is automatically updated to reflect the new group and corresponding prices. - If using the `customerGroupAssignments` field (for multiple Customer Groups), the Cart no longer keeps a direct reference to a Customer Group. If a Customer’s group assignments change, the Cart and its Line Item prices are not updated automatically. Prices are only updated when the Cart is changed via a direct update action.  Specific Error Codes:  - MatchingPriceNotFound - MissingTaxRateForCountry |
| [`commercetools_orders_create_orders`](#commercetools_orders_create_orders)                                                           | Creates an Order from a Cart.  The Cart must have a shipping address and an active Shipping Method set.  The shipping address is used for tax calculation for a Cart with `Platform` TaxMode.  Creating an Order produces the OrderCreated Message. If the Order is created from a Recurring Order schedule, the OrderCreatedFromRecurringOrder Message is generated.  If a server-side problem occurs, indicated by a 500 Internal Server Error HTTP response, the Order creation may still successfully complete after the error is returned. If you receive this error, you should verify the status of the Order by querying a unique identifier supplied during the creation request, such as the Order number.  Specific Error Codes:  - OutOfStock - PriceChanged - DiscountCodeNonApplicable - ShippingMethodDoesNotMatchCart - InvalidItemShippingDetails - InvalidOperation - MatchingPriceNotFound - MissingTaxRateForCountry                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_orders_create_orders_edits`](#commercetools_orders_create_orders_edits)                                               | Creates an OrderEdit in the Project. You can either create multiple Order Edits for an Order and apply them sequentially to an Order, or create multiple Order Edits parallelly (as alternatives to each other) and apply one of them to the Order.  You can only create an Order Edit if the InventoryMode of the Order and its LineItems is `None`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_orders_create_orders_edits_apply_by_id`](#commercetools_orders_create_orders_edits_apply_by_id)                       | Applying an OrderEdit produces the OrderEditApplied Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| [`commercetools_orders_create_orders_import`](#commercetools_orders_create_orders_import)                                             | Creates an Order without needing to create a Cart first. Importing an Order produces the Order Imported Message.  Specific Error Codes:  - OutOfStock - CountryNotConfiguredInStore                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| [`commercetools_orders_create_orders_order_number_order_number`](#commercetools_orders_create_orders_order_number_order_number)       | Updates an Order in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_orders_create_orders_quotes`](#commercetools_orders_create_orders_quotes)                                             | Creates an Order from a Quote. The referenced Quote must have the `Pending` state and must be valid (not past the `validTo` date); otherwise, an InvalidOperation error is returned.  Produces the OrderCreated Message.  Specific Error Codes:  - CountryNotConfiguredInStore - InvalidItemShippingDetails - InvalidOperation - OutOfStock                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| [`commercetools_orders_create_orders_search`](#commercetools_orders_create_orders_search)                                             | POST /orders/search                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| [`commercetools_orders_create_payment_methods`](#commercetools_orders_create_payment_methods)                                         | Creates a PaymentMethod in the Project. This request generates the PaymentMethodCreated Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| [`commercetools_orders_create_payments`](#commercetools_orders_create_payments)                                                       | Creates a Payment in the Project. Creating a Payment produces the PaymentCreated Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| [`commercetools_orders_delete_by_id`](#commercetools_orders_delete_by_id)                                                             | Deletes an Order in the Project. Deleting an Order produces the OrderDeleted Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_orders_delete_carts_by_id`](#commercetools_orders_delete_carts_by_id)                                                 | Deletes a Cart in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_orders_delete_carts_by_key`](#commercetools_orders_delete_carts_by_key)                                               | Deletes a Cart in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_orders_delete_edits_by_id`](#commercetools_orders_delete_edits_by_id)                                                 | Deletes an OrderEdit in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| [`commercetools_orders_delete_edits_by_key`](#commercetools_orders_delete_edits_by_key)                                               | Deletes an OrderEdit in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| [`commercetools_orders_delete_order_number_order_number`](#commercetools_orders_delete_order_number_order_number)                     | Deletes an Order in the Project. Deleting an Order produces the OrderDeleted Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_orders_delete_payment_methods_by_id`](#commercetools_orders_delete_payment_methods_by_id)                             | Deletes a PaymentMethod in the Project. This request generates the PaymentMethodDeleted Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| [`commercetools_orders_delete_payment_methods_by_key`](#commercetools_orders_delete_payment_methods_by_key)                           | Deletes a PaymentMethod in the Project. This request generates the PaymentMethodDeleted Message.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| [`commercetools_orders_delete_payments_by_id`](#commercetools_orders_delete_payments_by_id)                                           | Deletes a Payment in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_orders_delete_payments_by_key`](#commercetools_orders_delete_payments_by_key)                                         | Deletes a Payment in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_orders_get_by_id`](#commercetools_orders_get_by_id)                                                                   | Retrieves an Order with the provided `id`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| [`commercetools_orders_get_carts_by_id`](#commercetools_orders_get_carts_by_id)                                                       | Retrieves a Cart with the provided `id`. To ensure the Cart is up-to-date with current values (such as Prices and Discounts), use the Recalculate update action.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| [`commercetools_orders_get_carts_by_key`](#commercetools_orders_get_carts_by_key)                                                     | Retrieves a Cart with the provided `key`. To ensure the Cart is up-to-date with current values (such as Prices and Discounts), use the Recalculate update action.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_orders_get_edits_by_id`](#commercetools_orders_get_edits_by_id)                                                       | Retrieves an OrderEdit with the provided `id`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| [`commercetools_orders_get_edits_by_key`](#commercetools_orders_get_edits_by_key)                                                     | Retrieves an OrderEdit with the provided `key`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| [`commercetools_orders_get_payment_methods_by_id`](#commercetools_orders_get_payment_methods_by_id)                                   | Retrieves a PaymentMethod with the provided `id`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_orders_get_payment_methods_by_key`](#commercetools_orders_get_payment_methods_by_key)                                 | Retrieves a PaymentMethod with the provided `key`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| [`commercetools_orders_get_payments_by_id`](#commercetools_orders_get_payments_by_id)                                                 | Retrieves a Payment with the provided `id`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| [`commercetools_orders_get_payments_by_key`](#commercetools_orders_get_payments_by_key)                                               | Retrieves a Payment with the provided `key`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| [`commercetools_orders_list_carts`](#commercetools_orders_list_carts)                                                                 | Retrieves Carts in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| [`commercetools_orders_list_carts_customer_id_customer_id`](#commercetools_orders_list_carts_customer_id_customer_id)                 | Retrieves the most recently modified active Cart of a Customer with CartOrigin `Customer`. If no active Cart exists, this method returns a ResourceNotFound error.  To ensure the Cart is up-to-date with current values (such as Prices and Discounts), use the Recalculate update action.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |
| [`commercetools_orders_list_orders`](#commercetools_orders_list_orders)                                                               | Retrieves Orders in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 |
| [`commercetools_orders_list_orders_edits`](#commercetools_orders_list_orders_edits)                                                   | Retrieves OrderEdits in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| [`commercetools_orders_list_orders_order_number_order_number`](#commercetools_orders_list_orders_order_number_order_number)           | Retrieves an Order with the provided `orderNumber`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| [`commercetools_orders_list_payment_methods`](#commercetools_orders_list_payment_methods)                                             | Retrieves all PaymentMethods in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     |
| [`commercetools_orders_list_payments`](#commercetools_orders_list_payments)                                                           | Retrieves Payments in the Project.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| [`commercetools_orders_update_carts_by_id`](#commercetools_orders_update_carts_by_id)                                                 | Updates a Cart in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| [`commercetools_orders_update_carts_by_key`](#commercetools_orders_update_carts_by_key)                                               | Updates a Cart in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  |
| [`commercetools_orders_update_orders_by_id`](#commercetools_orders_update_orders_by_id)                                               | Updates an Order in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |
| [`commercetools_orders_update_orders_edits_by_id`](#commercetools_orders_update_orders_edits_by_id)                                   | Updates an OrderEdit in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_orders_update_orders_edits_by_key`](#commercetools_orders_update_orders_edits_by_key)                                 | Updates an OrderEdit in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| [`commercetools_orders_update_payment_methods_by_id`](#commercetools_orders_update_payment_methods_by_id)                             | Updates a PaymentMethod in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_orders_update_payment_methods_by_key`](#commercetools_orders_update_payment_methods_by_key)                           | Updates a PaymentMethod in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| [`commercetools_orders_update_payments_by_id`](#commercetools_orders_update_payments_by_id)                                           | Updates a Payment in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| [`commercetools_orders_update_payments_by_key`](#commercetools_orders_update_payments_by_key)                                         | Updates a Payment in the Project using one or more update actions.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |

***

## commercetools\_orders\_create\_carts

Creates a Cart in the Project.  If the referenced ShippingMethod in the CartDraft has a predicate that does not match, or if the Shipping Method is not active, an InvalidOperation error is returned.  Specific Error Codes:  - DiscountCodeNonApplicable - InvalidItemShippingDetails - MatchingPriceNotFound - MissingTaxRateForCountry

**Parameters:**

| Parameter                          | Type      | Required | Default | Description                           |
| ---------------------------------- | --------- | -------- | ------- | ------------------------------------- |
| `expand`                           | string\[] | No       | —       | Related resources to expand inline    |
| `anonymousId`                      | string    | No       | —       | Anonymous Id                          |
| `billingAddress`                   | object    | No       | —       | Billing Address                       |
| `businessUnit`                     | object    | No       | —       | Business Unit                         |
| `country`                          | string    | No       | —       | The country value                     |
| `currency`                         | string    | Yes      | —       | The currency value                    |
| `custom`                           | object    | No       | —       | The custom value                      |
| `customerEmail`                    | string    | No       | —       | Customer Email                        |
| `customerGroup`                    | object    | No       | —       | Customer Group                        |
| `customerId`                       | string    | No       | —       | Customer Id                           |
| `customLineItems`                  | object\[] | No       | —       | Custom Line Items                     |
| `customShipping`                   | object\[] | No       | —       | Custom Shipping                       |
| `deleteDaysAfterLastModification`  | integer   | No       | —       | Delete Days After Last Modification   |
| `discountCodes`                    | string\[] | No       | —       | Discount Codes                        |
| `externalTaxRateForShippingMethod` | object    | No       | —       | External Tax Rate For Shipping Method |
| `inventoryMode`                    | string    | No       | —       | Inventory Mode                        |
| `itemShippingAddresses`            | object\[] | No       | —       | Item Shipping Addresses               |
| `key`                              | string    | No       | —       | The key value                         |
| `lineItems`                        | object\[] | No       | —       | Line Items                            |
| `locale`                           | string    | No       | —       | Locale or language code               |
| `origin`                           | string    | No       | —       | The origin value                      |
| `priceRoundingMode`                | string    | No       | —       | Price Rounding Mode                   |
| `purchaseOrderNumber`              | string    | No       | —       | Purchase Order Number                 |
| `shipping`                         | object\[] | No       | —       | The shipping value                    |
| `shippingAddress`                  | object    | No       | —       | Shipping Address                      |
| `shippingMethod`                   | object    | No       | —       | Shipping Method                       |
| `shippingMode`                     | string    | No       | —       | Shipping Mode                         |
| `shippingRateInput`                | object    | No       | —       | Shipping Rate Input                   |
| `store`                            | object    | No       | —       | The store value                       |
| `taxCalculationMode`               | string    | No       | —       | Tax Calculation Mode                  |
| `taxMode`                          | string    | No       | —       | Tax Mode                              |
| `taxRoundingMode`                  | string    | No       | —       | Tax Rounding Mode                     |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "expand": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Related resources to expand inline"
      },
      "anonymousId": {
        "type": "string",
        "description": "Anonymous Id"
      },
      "billingAddress": {
        "type": "object",
        "description": "Billing Address",
        "properties": {
          "id": {
            "type": "string",
            "description": "The id value"
          },
          "key": {
            "type": "string",
            "description": "The key value"
          },
          "country": {
            "type": "string",
            "description": "The country value"
          },
          "title": {
            "type": "string",
            "description": "The title value"
          },
          "salutation": {
            "type": "string",
            "description": "The salutation value"
          },
          "firstName": {
            "type": "string",
            "description": "First Name"
          },
          "lastName": {
            "type": "string",
            "description": "Last Name"
          },
          "streetName": {
            "type": "string",
            "description": "Street Name"
          },
          "streetNumber": {
            "type": "string",
            "description": "Street Number"
          },
          "additionalStreetInfo": {
            "type": "string",
            "description": "Additional Street Info"
          },
          "postalCode": {
            "type": "string",
            "description": "Postal Code"
          },
          "city": {
            "type": "string",
            "description": "The city value"
          },
          "region": {
            "type": "string",
            "description": "The region value"
          },
          "state": {
            "type": "string",
            "description": "The state value"
          },
          "company": {
            "type": "string",
            "description": "The company value"
          },
          "department": {
            "type": "string",
            "description": "The department value"
          },
          "building": {
            "type": "string",
            "description": "The building value"
          },
          "apartment": {
            "type": "string",
            "description": "The apartment value"
          },
          "pOBox": {
            "type": "string",
            "description": "P O Box"
          },
          "phone": {
            "type": "string",
            "description": "The phone value"
          },
          "mobile": {
            "type": "string",
            "description": "The mobile value"
          },
          "email": {
            "type": "string",
            "description": "The email value"
          },
          "fax": {
            "type": "string",
            "description": "The fax value"
          },
          "additionalAddressInfo": {
            "type": "string",
            "description": "Additional Address Info"
          },
          "externalId": {
            "type": "string",
            "description": "External Id"
          }
        },
        "required": [
          "country"
        ]
      },
      "businessUnit": {
        "description": "Business Unit"
      },
      "country": {
        "type": "string",
        "description": "The country value"
      },
      "currency": {
        "type": "string",
        "description": "The currency value"
      },
      "custom": {
        "type": "object",
        "description": "The custom value",
        "properties": {
          "type": {
            "description": "The type value"
          },
          "fields": {
            "type": "object",
            "description": "The fields value"
          }
        },
        "required": [
          "type"
        ]
      },
      "customerEmail": {
        "type": "string",
        "description": "Customer Email"
      },
      "customerGroup": {
        "description": "Customer Group"
      },
      "customerId": {
        "type": "string",
        "description": "Customer Id"
      },
      "customLineItems": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "object",
              "description": "The name value"
            },
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "quantity": {
              "type": "integer",
              "format": "int64",
              "description": "The quantity value"
            },
            "money": {
              "type": "object",
              "description": "The money value"
            },
            "slug": {
              "type": "string",
              "description": "The slug value"
            },
            "taxCategory": {
              "description": "Tax Category"
            },
            "externalTaxRate": {
              "type": "object",
              "description": "External Tax Rate"
            },
            "custom": {
              "type": "object",
              "description": "The custom value"
            },
            "shippingDetails": {
              "type": "object",
              "description": "Shipping Details"
            },
            "priceMode": {
              "type": "string",
              "enum": [
                "Standard",
                "External"
              ],
              "description": "Price Mode"
            },
            "recurrenceInfo": {
              "type": "object",
              "description": "Recurrence Info"
            }
          },
          "required": [
            "money",
            "name",
            "slug"
          ]
        },
        "description": "Custom Line Items"
      },
      "customShipping": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "shippingMethodName": {
              "type": "string",
              "description": "Shipping Method Name"
            },
            "shippingAddress": {
              "type": "object",
              "description": "Shipping Address"
            },
            "shippingRate": {
              "type": "object",
              "description": "Shipping Rate"
            },
            "shippingRateInput": {
              "type": "object",
              "description": "Shipping Rate Input"
            },
            "taxCategory": {
              "description": "Tax Category"
            },
            "externalTaxRate": {
              "type": "object",
              "description": "External Tax Rate"
            },
            "deliveries": {
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "key": {
                    "type": "string"
                  },
                  "items": {
                    "type": "array"
                  },
                  "parcels": {
                    "type": "array"
                  },
                  "address": {},
                  "custom": {
                    "type": "object"
                  }
                }
              },
              "description": "The deliveries value"
            },
            "custom": {
              "type": "object",
              "description": "The custom value"
            }
          },
          "required": [
            "key",
            "shippingMethodName",
            "shippingRate"
          ]
        },
        "description": "Custom Shipping"
      },
      "deleteDaysAfterLastModification": {
        "type": "integer",
        "description": "Delete Days After Last Modification"
      },
      "discountCodes": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "Discount Codes"
      },
      "externalTaxRateForShippingMethod": {
        "type": "object",
        "description": "External Tax Rate For Shipping Method",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name value"
          },
          "amount": {
            "type": "number",
            "description": "The amount value"
          },
          "includedInPrice": {
            "type": "boolean",
            "description": "Included In Price"
          },
          "country": {
            "type": "string",
            "description": "The country value"
          },
          "state": {
            "type": "string",
            "description": "The state value"
          },
          "subRates": {
            "type": "array",
            "items": {
              "type": "object"
            },
            "description": "Sub Rates"
          }
        },
        "required": [
          "country",
          "name"
        ]
      },
      "inventoryMode": {
        "type": "string",
        "description": "Inventory Mode",
        "enum": [
          "None",
          "TrackOnly",
          "ReserveOnOrder"
        ]
      },
      "itemShippingAddresses": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "id": {
              "type": "string",
              "description": "The id value"
            },
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "country": {
              "type": "string",
              "description": "The country value"
            },
            "title": {
              "type": "string",
              "description": "The title value"
            },
            "salutation": {
              "type": "string",
              "description": "The salutation value"
            },
            "firstName": {
              "type": "string",
              "description": "First Name"
            },
            "lastName": {
              "type": "string",
              "description": "Last Name"
            },
            "streetName": {
              "type": "string",
              "description": "Street Name"
            },
            "streetNumber": {
              "type": "string",
              "description": "Street Number"
            },
            "additionalStreetInfo": {
              "type": "string",
              "description": "Additional Street Info"
            },
            "postalCode": {
              "type": "string",
              "description": "Postal Code"
            },
            "city": {
              "type": "string",
              "description": "The city value"
            },
            "region": {
              "type": "string",
              "description": "The region value"
            },
            "state": {
              "type": "string",
              "description": "The state value"
            },
            "company": {
              "type": "string",
              "description": "The company value"
            },
            "department": {
              "type": "string",
              "description": "The department value"
            },
            "building": {
              "type": "string",
              "description": "The building value"
            },
            "apartment": {
              "type": "string",
              "description": "The apartment value"
            },
            "pOBox": {
              "type": "string",
              "description": "P O Box"
            },
            "phone": {
              "type": "string",
              "description": "The phone value"
            },
            "mobile": {
              "type": "string",
              "description": "The mobile value"
            },
            "email": {
              "type": "string",
              "description": "The email value"
            },
            "fax": {
              "type": "string",
              "description": "The fax value"
            },
            "additionalAddressInfo": {
              "type": "string",
              "description": "Additional Address Info"
            },
            "externalId": {
              "type": "string",
              "description": "External Id"
            }
          },
          "required": [
            "country"
          ]
        },
        "description": "Item Shipping Addresses"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "lineItems": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "productId": {
              "type": "string",
              "description": "Product Id"
            },
            "variantId": {
              "type": "integer",
              "format": "int64",
              "description": "Variant Id"
            },
            "sku": {
              "type": "string",
              "description": "The sku value"
            },
            "quantity": {
              "type": "integer",
              "format": "int64",
              "description": "The quantity value"
            },
            "addedAt": {
              "type": "string",
              "format": "datetime",
              "description": "Added At"
            },
            "distributionChannel": {
              "description": "Distribution Channel"
            },
            "supplyChannel": {
              "description": "Supply Channel"
            },
            "externalPrice": {
              "type": "object",
              "description": "External Price"
            },
            "externalTotalPrice": {
              "type": "object",
              "description": "External Total Price"
            },
            "externalTaxRate": {
              "type": "object",
              "description": "External Tax Rate"
            },
            "perMethodExternalTaxRate": {
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "shippingMethodKey": {
                    "type": "string"
                  },
                  "taxRate": {
                    "type": "object"
                  }
                }
              },
              "description": "Per Method External Tax Rate"
            },
            "inventoryMode": {
              "type": "string",
              "enum": [
                "None",
                "TrackOnly",
                "ReserveOnOrder"
              ],
              "description": "Inventory Mode"
            },
            "shippingDetails": {
              "type": "object",
              "description": "Shipping Details"
            },
            "custom": {
              "type": "object",
              "description": "The custom value"
            },
            "recurrenceInfo": {
              "type": "object",
              "description": "Recurrence Info"
            }
          }
        },
        "description": "Line Items"
      },
      "locale": {
        "type": "string",
        "description": "Locale or language code"
      },
      "origin": {
        "type": "string",
        "description": "The origin value",
        "enum": [
          "Customer",
          "Merchant",
          "Quote",
          "RecurringOrder"
        ]
      },
      "priceRoundingMode": {
        "type": "string",
        "description": "Price Rounding Mode",
        "enum": [
          "HalfEven",
          "HalfUp",
          "HalfDown"
        ]
      },
      "purchaseOrderNumber": {
        "type": "string",
        "description": "Purchase Order Number"
      },
      "shipping": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "key": {
              "type": "string",
              "description": "The key value"
            },
            "shippingMethod": {
              "description": "Shipping Method"
            },
            "shippingAddress": {
              "type": "object",
              "description": "Shipping Address"
            },
            "shippingRateInput": {
              "type": "object",
              "description": "Shipping Rate Input"
            },
            "externalTaxRate": {
              "type": "object",
              "description": "External Tax Rate"
            },
            "deliveries": {
              "type": "array",
              "items": {
                "type": "object",
                "properties": {
                  "key": {
                    "type": "string"
                  },
                  "items": {
                    "type": "array"
                  },
                  "parcels": {
                    "type": "array"
                  },
                  "address": {},
                  "custom": {
                    "type": "object"
                  }
                }
              },
              "description": "The deliveries value"
            },
            "custom": {
              "type": "object",
              "description": "The custom value"
            }
          },
          "required": [
            "key",
            "shippingAddress"
          ]
        },
        "description": "The shipping value"
      },
      "shippingAddress": {
        "type": "object",
        "description": "Shipping Address",
        "properties": {
          "id": {
            "type": "string",
            "description": "The id value"
          },
          "key": {
            "type": "string",
            "description": "The key value"
          },
          "country": {
            "type": "string",
            "description": "The country value"
          },
          "title": {
            "type": "string",
            "description": "The title value"
          },
          "salutation": {
            "type": "string",
            "description": "The salutation value"
          },
          "firstName": {
            "type": "string",
            "description": "First Name"
          },
          "lastName": {
            "type": "string",
            "description": "Last Name"
          },
          "streetName": {
            "type": "string",
            "description": "Street Name"
          },
          "streetNumber": {
            "type": "string",
            "description": "Street Number"
          },
          "additionalStreetInfo": {
            "type": "string",
            "description": "Additional Street Info"
          },
          "postalCode": {
            "type": "string",
            "description": "Postal Code"
          },
          "city": {
            "type": "string",
            "description": "The city value"
          },
          "region": {
            "type": "string",
            "description": "The region value"
          },
          "state": {
            "type": "string",
            "description": "The state value"
          },
          "company": {
            "type": "string",
            "description": "The company value"
          },
          "department": {
            "type": "string",
            "description": "The department value"
          },
          "building": {
            "type": "string",
            "description": "The building value"
          },
          "apartment": {
            "type": "string",
            "description": "The apartment value"
          },
          "pOBox": {
            "type": "string",
            "description": "P O Box"
          },
          "phone": {
            "type": "string",
            "description": "The phone value"
          },
          "mobile": {
            "type": "string",
            "description": "The mobile value"
          },
          "email": {
            "type": "string",
            "description": "The email value"
          },
          "fax": {
            "type": "string",
            "description": "The fax value"
          },
          "additionalAddressInfo": {
            "type": "string",
            "description": "Additional Address Info"
          },
          "externalId": {
            "type": "string",
            "description": "External Id"
          }
        },
        "required": [
          "country"
        ]
      },
      "shippingMethod": {
        "description": "Shipping Method"
      },
      "shippingMode": {
        "type": "string",
        "description": "Shipping Mode",
        "enum": [
          "Single",
          "Multiple"
        ]
      },
      "shippingRateInput": {
        "type": "object",
        "description": "Shipping Rate Input",
        "properties": {
          "type": {
            "type": "string",
            "description": "The type value"
          }
        },
        "required": [
          "type"
        ]
      },
      "store": {
        "description": "The store value"
      },
      "taxCalculationMode": {
        "type": "string",
        "description": "Tax Calculation Mode",
        "enum": [
          "LineItemLevel",
          "UnitPriceLevel"
        ]
      },
      "taxMode": {
        "type": "string",
        "description": "Tax Mode",
        "enum": [
          "Platform",
          "External",
          "ExternalAmount",
          "Disabled"
        ]
      },
      "taxRoundingMode": {
        "type": "string",
        "description": "Tax Rounding Mode",
        "enum": [
          "HalfEven",
          "HalfUp",
          "HalfDown"
        ]
      }
    },
    "required": [
      "PCID",
      "currency"
    ]
  }
  ```
</Expandable>

***

## commercetools\_orders\_create\_carts\_customer\_id\_customer\_id\_merge

Merges items from an anonymous Cart into the most recently modified active Cart of a Customer. If no active Cart exists, the anonymous Cart becomes the Customer's active Cart. For more information about merge mode behaviors, merge rules, and tax recalculation, see Merge a Cart.

**Parameters:**

| Parameter           | Type    | Required | Default | Description         |
| ------------------- | ------- | -------- | ------- | ------------------- |
| `customerId`        | string  | Yes      | —       | Customer Id         |
| `anonymousCart`     | object  | No       | —       | Anonymous Cart      |
| `anonymousId`       | string  | No       | —       | Anonymous Id        |
| `mergeMode`         | string  | No       | —       | Merge Mode          |
| `updateProductData` | boolean | No       | —       | Update Product Data |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "customerId": {
        "type": "string",
        "description": "Customer Id"
      },
      "anonymousCart": {
        "description": "Anonymous Cart"
      },
      "anonymousId": {
        "type": "string",
        "description": "Anonymous Id"
      },
      "mergeMode": {
        "type": "string",
        "description": "Merge Mode",
        "enum": [
          "MergeWithExistingCustomerCart",
          "UseAsNewActiveCustomerCart"
        ]
      },
      "updateProductData": {
        "type": "boolean",
        "description": "Update Product Data"
      }
    },
    "required": [
      "PCID",
      "customerId"
    ]
  }
  ```
</Expandable>

***

## commercetools\_orders\_create\_carts\_replicate

Creates a new Cart by replicating an existing Cart or Order.  The following applies to the new Cart:  - It contains the same Customer information, Line Items and Custom Line Items, Custom Fields, Discount Codes, and other settings of the originating Cart or Order. - If a Line Item becomes invalid, it is removed from the new Cart. A common reason for this is removed Products or Prices. - Line items and Custom Line Items are reset to their initial state. - It contains no payments or delivery information. - It contains up-to-date Tax Rates, Prices, and Line Item product data. - The CartState is `Active`. - If using the `customerGroup` field (for a single Customer Group) and the referenced Customer switched to another Customer Group, the new Cart is automatically updated to reflect the new group and corresponding prices. - If using the `customerGroupAssignments` field (for multiple Customer Groups), the Cart no longer keeps a direct reference to a Customer Group. If a Customer’s group assignments change, the Cart and its Line Item prices are not updated automatically. Prices are only updated when the Cart is changed via a direct update action.  Specific Error Codes:  - MatchingPriceNotFound - MissingTaxRateForCountry

**Parameters:**

| Parameter   | Type   | Required | Default | Description         |
| ----------- | ------ | -------- | ------- | ------------------- |
| `key`       | string | No       | —       | The key value       |
| `reference` | object | Yes      | —       | The reference value |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "key": {
        "type": "string",
        "description": "The key value"
      },
      "reference": {
        "description": "The reference value"
      }
    },
    "required": [
      "PCID",
      "reference"
    ]
  }
  ```
</Expandable>

***

## commercetools\_orders\_create\_orders

Creates an Order from a Cart.  The Cart must have a shipping address and an active Shipping Method set.  The shipping address is used for tax calculation for a Cart with `Platform` TaxMode.  Creating an Order produces the OrderCreated Message. If the Order is created from a Recurring Order schedule, the OrderCreatedFromRecurringOrder Message is generated.  If a server-side problem occurs, indicated by a 500 Internal Server Error HTTP response, the Order creation may still successfully complete after the error is returned. If you receive this error, you should verify the status of the Order by querying a unique identifier supplied during the creation request, such as the Order number.  Specific Error Codes:  - OutOfStock - PriceChanged - DiscountCodeNonApplicable - ShippingMethodDoesNotMatchCart - InvalidItemShippingDetails - InvalidOperation - MatchingPriceNotFound - MissingTaxRateForCountry

**Parameters:**

| Parameter             | Type      | Required | Default | Description                        |
| --------------------- | --------- | -------- | ------- | ---------------------------------- |
| `expand`              | string\[] | No       | —       | Related resources to expand inline |
| `cart`                | object    | No       | —       | The cart value                     |
| `custom`              | object    | No       | —       | The custom value                   |
| `id`                  | string    | No       | —       | The id value                       |
| `orderNumber`         | string    | No       | —       | Order Number                       |
| `orderState`          | string    | No       | —       | Order State                        |
| `paymentState`        | string    | No       | —       | Payment State                      |
| `purchaseOrderNumber` | string    | No       | —       | Purchase Order Number              |
| `shipmentState`       | string    | No       | —       | Shipment State                     |
| `state`               | object    | No       | —       | The state value                    |
| `version`             | integer   | Yes      | —       | The version value                  |

[...]
